class Object
  def cig(*args)
    args = args.dup

    if block_given?
      raise ArgumentError, 'Do not pass this method both a block and other arguments.' if args.any?
      return yield self
    end

    obj, meth = args.first.is_a?(Symbol) ? [self, args.shift] : [args.shift, args.shift]

    send_meth = obj == self ? :send : :public_send
    obj.send send_meth, meth, self, *args
  end

  alias_method :_?, :cig
end
